import sys,os
argv=sys.argv
try:
    contig_file=argv[1]
    now_count=argv[2]
except:
    contig_file="2_Contigs_B.fa"
    now_count="1"
c_nt=dict()
c_nt['A']='T';c_nt['T']='A';c_nt['C']='G';c_nt['G']='C'
def complement(seq):
    global c_nt
    s_list=list(seq)
    s_list.reverse()
    new_s_list=[]
    for i in range(len(s_list)):
        now_nt=s_list[i]
        if now_nt in['A','T','C','G']:new_s_list.append(c_nt[now_nt])
        else:new_s_list.append(now_nt)
    return ''.join(new_s_list)
    
def Get_Contigs(file_name):
    my_dict=dict()
    f=open(file_name)
    for i in f:
        if '>' in i:h=i.replace('>','').replace('\n','');my_dict[h]='';continue
        my_dict[h]+=(i.replace('\n','').upper())
    f.close()
    return my_dict

#def To_Connect(file_name,Sides,Bridges,target_bridge):
def To_Connect(file_name,Sides,target_bridge):
    bridges_info_clr=[]
    bridges_info_assembler=[]
    fw_a=open('2_aliases.txt','w')
    fw_contig=open('2_Contigs_B.fa','w')
    f=open(file_name)
    #if clr is bridge put it to bridges_info_clr
    #if assembler's ctg is bridge put it to bridges_info_assembler
    for i in f:
        #target_bridge => clr
        if i[:3] != target_bridge:bridges_info_assembler.append(i.replace('\n',''));continue#only get clr as bridge
        bridges_info_clr.append(i.replace('\n',''))
    f.close()

    #at first, use clr as bridge
    fw_filed=open('Filtered_1_Bridges_clr_as_Bridge.txt','w')
    if len(bridges_info_clr)>0:
        #long bridge at first
        bridges_info=sorted(bridges_info_clr,key=lambda x:int(x.split()[0].split(':')[1]),reverse=True)

        clr_to_ctg_ctg=[]
        clr_to_ctg_clr=[]
        tmp_bridges_info=[]
        
        #for i in bridges_info:fw_filed.write(i+'\n')
        for i in range(0,len(bridges_info),2):
            #if clr as bridge to connect clr and clr, skip
            #target_bridge => clr
            info1=bridges_info[i].split()
            info2=bridges_info[i+1].split()
            
            bridge_name=info1[0];side1_name=info1[1];side2_name=info2[1]
            if (target_bridge in bridge_name) and (target_bridge in side1_name) and (target_bridge in side2_name):continue

            if (target_bridge in side1_name) or (target_bridge in side2_name):
                clr_to_ctg_clr.append(bridges_info[i])
                clr_to_ctg_clr.append(bridges_info[i+1])
            else:
                clr_to_ctg_ctg.append(bridges_info[i])
                clr_to_ctg_ctg.append(bridges_info[i+1])                
        #Use bridge at first, which clr_bridge to connect ctg and ctg
        for i in (clr_to_ctg_ctg+clr_to_ctg_clr):
            tmp_bridges_info.append(i)
            fw_filed.write(i+'\n')
        bridges_info=tmp_bridges_info
    fw_filed.close()
    
    #when all clr_bridges are used up, use assembler's ctg as bridge
    if os.path.getsize('Filtered_1_Bridges_clr_as_Bridge.txt')==0:
        clr_to_ctg_ctg=[]
        clr_to_ctg_clr=[]
        tmp_bridges_info=[]
        bridges_info=sorted(bridges_info_assembler,key=lambda x:int(x.split()[0].split(':')[1]),reverse=True)
        for i in range(0,len(bridges_info),2):
            info1=bridges_info[i].split()
            info2=bridges_info[i+1].split()

            bridge_name=info1[0];side1_name=info1[1];side2_name=info2[1]
            if (target_bridge in side1_name) or (target_bridge in side2_name):
                clr_to_ctg_clr.append(bridges_info[i])
                clr_to_ctg_clr.append(bridges_info[i+1])
            else:
                clr_to_ctg_ctg.append(bridges_info[i])
                clr_to_ctg_ctg.append(bridges_info[i+1])
                
        fw_filed=open('Filtered_1_Bridges_assembler_ctg_as_Bridge.txt','w')
        #Use bridge at first, which ctg_bridge to connect ctg and ctg
        for i in (clr_to_ctg_ctg+clr_to_ctg_clr):
            tmp_bridges_info.append(i)
            fw_filed.write(i+'\n')
        fw_filed.close()
        bridges_info=tmp_bridges_info
        
    # Rule, according to bridges_into to column 4, 5 to remove sides
    # and then side1 + bridge + side2 => new_contigs
#Velvet_30_len:155	Velvet_156_211205_splited_1_len:204782	1	104	204679	204782	104	4e-50	104
#Velvet_30_len:155	Velvet_156_211205_splited_2_len:81	111	155	1	45	45	3e-17	45
    count=1
    for i in range(0,len(bridges_info),2):
        info1=bridges_info[i].split()
        info2=bridges_info[i+1].split()
        #1 side1 = side2 => skip
        if info1[1]==info2[1]:continue
        
        try:
            bridge=Sides[info1[0]]
            bridge_len=int(info1[0].split(":")[1])
            #process this condition => 10 ambiguous => clr123_len:9797   abyssxxx 2 3877
            #                                          clr123_len:9797   edenaxxx 4005 9797
            len_list=[]
            bridge1_s=int(info1[2]);bridge1_e=int(info1[3]);bridge2_s=int(info2[2]);bridge2_e=int(info2[3])
            #len_list.append(bridge1_s);len_list.append(bridge1_e);
            #len_list.append(bridge2_s);len_list.append(bridge2_e);
            #len_list=sorted(len_list)
# side1 and side2 have overlap
#clr_16693_len:11666	Velvet_250_40423_split_2_len:15427	1	10804	4624	15427	10804	0.0	10804
#clr_16693_len:11666	clr_10162_len:7321	10045	11666	7321	5701	1622	0.0	1597
# side1 and side2 doesn't have overlap
#clr_3091_len:10443	Abyss_54_107319_split_2_len:34348	1	3048	31301	34348	3048	0.0	3048
#clr_3091_len:10443	Abyss_54_107319_split_3_len:71208	3051	10443	1	7392	7393	0.0	7389

            #b_start=len_list[0];b_end=len_list[-1]
            #bridge=bridge[b_start-1:b_end]

            if bridge1_e>bridge2_s:
                bridge=bridge1_e-bridge2_s
            else:
                bridge=bridge[bridge1_e-1:bridge2_s]
            
            side1=list(Sides[info1[1]])
            side2=list(Sides[info2[1]])
        except:
            #2 if the Side have beed used(has beed pop), skip it
            continue
        print '%s to connect %s and %s'%(info1[0],info1[1],info2[1])
        side1_s_int=int(info1[4]);side1_e_int=int(info1[5])
        side2_s_int=int(info2[4]);side2_e_int=int(info2[5])

        #use side to merge bridge
        if type(bridge)==type(1):#if bridge is int (means side1 and side2 have overlap), use longer to merge shorter.
            if len(side1)>len(side2):#side2 at tail=> side1 at bridge's left, side2 at bridge's right
                if side2_s_int<side2_e_int:
                    side2[:bridge]=[]
                if side2_s_int>side2_e_int:
                    side2[-bridge:]=[]
                    side2=complement(side2)
                if side1_s_int>side1_e_int:
                    side1=complement(side1)
            else:#side2 is longer
                if side1_s_int<side1_e_int:#side1 at head=> side1 at bridge's left, side2 at bridge's right
                    side1[-bridge:]=[]
                if side1_s_int>side1_e_int:
                    side1[:bridge]=[]
                    side1=complement(side1)
                if side2_s_int>side2_e_int:
                    side2=complement(side2)
            side1=''.join(side1);side2=''.join(side2)
            connected_contig=side1+side2
        else:
            if side1_s_int>side1_e_int:
                side1=complement(side1)
            if side2_s_int>side2_e_int:
                side2=complement(side2)
            side1=''.join(side1);side2=''.join(side2)
            connected_contig=side1+bridge+side2

        #this condition: side and bridge come from the same file, so remeber to pop side and bridge.
        #pop side
        Sides.pop(info1[1]);Sides.pop(info2[1])
        #pop bridge
        Sides.pop(info1[0])
        fw_a.write('Connected_Contig_'+now_count+'_'+str(count)+'\tfrom:\t'+info1[1]+'\t'+info1[0]+'\t'+info2[1]+'\n')
        fw_contig.write('>Connected_Contig_'+now_count+'_'+str(count)+'_len:'+str(len(connected_contig))+'\n')
        fw_contig.write(connected_contig+'\n')
        count+=1
    for k in Sides.keys():
        fw_contig.write('>'+k+'\n')
        fw_contig.write(Sides[k]+'\n')
    fw_a.close();fw_contig.close()
    return (Sides)
    
def To_Extend(Bfile,Efile,Sides,Bridges):
    #Skip extension if it has been used by bridge
    b_list=[]
    f=open(Bfile)
    for i in f:
        tmp=i.split()
        b_list.append(tmp[1])
    f.close()
    E_list=[]
    f=open(Efile)
    for i in f:
        tmp=i.split()
        if tmp[1] in b_list:continue
        E_list.append(i.replace('\n',''))
    f.close()
    fw_contig=open('2_Contigs_B_E.fa','w');fw_a=open('2_alises.txt','a')
    #Start to Extend
#Extention Info
#Condition1: Velvet_58_len:104	Velvet_84_3218_splited_5_len:1064	1	48	1017	1064	48	4e-19	48
#Condition2: Velvet_26_len:462	SOAP_6_265355_splited_2_len:58302	255	462	58302	58095	208	2e-107	208
    count=1
    for i in E_list:
        info=i.split()
        bridge=Bridges[info[0]]
        side=list(Sides[info[1]])
        print '%s to extend with %s '%(info[0],info[1])
        side_s_int=int(info[4]);side_e_int=int(info[5])
        if side_s_int>side_e_int:
            side[side_e_int-1:side_s_int]=[]
            side=complement(side)
        else:
            side[side_s_int-1:side_e_int]=[]        
        side=''.join(side)
        if info[2]=='1':
            Extend_contig=side+bridge
            fw_a.write('Extended_Contig_'+now_count+'_'+str(count)+'\tfrom:\t'+info[1]+'\t'+info[0]+'\n')
        else:
            Extend_contig=bridge+side
            fw_a.write('Extended_Contig_'+now_count+'_'+str(count)+'\tfrom:\t'+info[0]+'\t'+info[1]+'\n')
        Sides.pop(info[1])
        fw_contig.write('>Extended_Contig_'+now_count+'_'+str(count)+'_len:'+str(len(Extend_contig))+'\n')
        fw_contig.write(Extend_contig+'\n')
        count+=1
    for k in Sides.keys():
        fw_contig.write('>'+k+'\n')
        fw_contig.write(Sides[k]+'\n')
    fw_a.close();fw_contig.close()

def To_Replace(file_name,Sides,Bridges):
    f=open(file_name)
    count=1
    for i in f:
        tmp=i.split()
        b_name=tmp[0]
        s_name=tmp[1]
        Sides.pop(s_name)
        new_b_name='Replaced_'+now_count+'_'+str(count)+'_'+b_name
        Sides[new_b_name]=Bridges[b_name]
        count+=1
    f.close()
    return (Sides,Bridges)


#--------------Main------------------
#only use clr as bridge
target_bridge="clr"

#this condition: Sides and Bridges come from the same file
Sides=Get_Contigs(contig_file)
#Bridges=Get_Contigs(contig_file)
#(Sides,Bridges)=To_Replace('1_Replace_data.txt',Sides,Bridges)
(Sides)=To_Connect('1_Bridges.txt',Sides,target_bridge)
#(Sides,Bridges)=To_Connect('1_Bridges.txt',Sides,Bridges,target_bridge)
#Sides=Get_Contigs('2_Contigs_B.fa')
#To_Extend('1_Bridges.txt','1_Extensions.txt',Sides,Bridges)





