import commands
import os
import filecmp
from Get_Explained import Get_Info_NUCMer
class R2_1:
    def Extend(self,infile,CISA_S,current_p):
        (s,o)=commands.getstatusoutput("python "+CISA_S+"/Merge/Filter1.py "+current_p)
        print o
        (s,o)=commands.getstatusoutput("python "+CISA_S+"/Merge/Extend.py "+infile+" "+current_p)
        print o
    def Trim(self,CISA_S,current_p):
        (s,o)=commands.getstatusoutput("python "+CISA_S+"/Merge/Trim.py "+current_p)
        print o
    def Get_explained_info(self,infile,current_p):
        try:
            f=open(current_p+'/explained.txt');
            #this round and last is same, so this_round_explain file is empty
            #if not os.path.exists(current_p+'/Step2/explained.txt'):#if this round explain is not exist
            #    f=open(last_current_p+'/Step2/explained.txt');#get last round's explain
            #else:
            #    f=open(current_p+'/Step2/explained.txt');

            explain_data=f.readlines()
            f.close()
            
            contig=open(infile)
            my_dict=dict()
            while True:
                h=contig.readline().replace('\n','')
                if not h:break
                s=contig.readline().replace('\n','')
                my_dict[h]=s

            
            fw=open(current_p+'/Merge_Contigs.fa','w')
            explained_ctg_set=set()
            for i in explain_data:
                if "RefID:" in i:continue
                for j in (i.replace('\n','').split()):#Get explained ctg name
                    explained_ctg_set.add('>'+j)
            for key in my_dict.keys():
                if key in explained_ctg_set:continue
                fw.write(key+'\n')
                fw.write(my_dict[key]+'\n')
            fw.close()

        except:#if this is first round , the explain file is empty => no contig is explained by other long ctg
            print "No Explained Condition."
    def rename(self,my_path,my_output,header):
        f=open(my_path)
        d=dict()
        for i in f:
            i=i.replace('\n','')
            if '>' in i:h=i;d[h]='';continue
            d[h]+=i
        f.close()

        fw=open(my_output,'w')
        mycount=1
        for i in d.keys():
            seq=d[i]
            h='>'+header+'_'+str(mycount)+'_len:'+str(len(seq))
            fw.write(h+'\n')
            fw.write(seq+'\n')
            mycount+=1
        fw.close()
    def Start(self,infile,nucmer,CISA_S,current_p,explained_ratio):
        print 'Merge....'
        
        f=open(infile);header=f.readline();f.close()
        if not '_len:' in header:
            self.rename(infile,'my_CLR.fa','clr');
            infile='my_CLR.fa'
            
        while True:
            my_current_p=current_p+("/Step2")
            
            mywork=Get_Info_NUCMer()
            mywork.Start(infile,nucmer,my_current_p,explained_ratio)
            self.Get_explained_info(infile,my_current_p)
            #(s,o)=commands.getstatusoutput("cp "+my_current_p+'/Merge/Merge_Contigs.fa'+" "+current_p+"/Step2")
            break
        print 'Merge Done!'
