import sys
try:
    argv=sys.argv
    infile=argv[1]
    genome_size=int(argv[2])
    depth=int(argv[3])
except:
    infile='my_CLR.fa'
    genome_size=4650000
    depth=15

clr_list=[]
f=open(infile)
for i in f:
    if '>' in i:continue
    clr_list.append(i.replace('\n',''))
f.close()

clr_list=sorted(clr_list,key=lambda seq:len(seq),reverse=True)
thr=genome_size*depth
amount=0
count=1;
fw=open(infile+'.Long.fa','w')
for seq in clr_list:
    if amount>thr:break
    fw.write('>clr_%d_len:%d\n'%(count,len(seq)))
    fw.write(seq+'\n')
    amount+=len(seq)
    count+=1
fw.close()
    

