import sys,re

c_nt=dict()
c_nt['A']='T';c_nt['T']='A';c_nt['C']='G';c_nt['G']='C'
def complement(seq):
    global c_nt
    s_list=list(seq)
    s_list.reverse()
    new_s_list=[]
    for i in range(len(s_list)):
        now_nt=s_list[i]
        if now_nt in['A','T','C','G']:new_s_list.append(c_nt[now_nt])
        else:new_s_list.append(now_nt)
    return ''.join(new_s_list)

def Get_Seq(my_path):
    my_d=dict()
    f=open(my_path)
    for i in f:
        i=i.replace('\n','')
        if '>' in i:h=i;my_d[h]='';continue
        my_d[h]+=i
    f.close()
    return my_d
def Gap_Filler(seq,clr_dict,fw1):
    seq=re.sub('N+','N',seq)
    tmp_seq=seq.split('N',1)#one time process one N block
    try:
        match_start=tmp_seq[0][-100:]
    except:
        match_start=tmp_seq[0]
    try:
        match_end=tmp_seq[1][:100]
    except:
        match_end=tmp_seq[1]

    pattern="(%s\w+%s)"%(match_start,match_end)
    #print pattern
    filled_seq=dict()
    for clr in clr_dict.keys():
        seq=clr_dict[clr]
        gap_related_seq='';gap_related_seq_r=''
        find_condition=re.search(pattern,seq)
        if find_condition:
            gap_related_seq=find_condition.group(1).replace(match_start,'').replace(match_end,'')
        find_condition=re.search(pattern,complement(seq))
        if find_condition:
            gap_related_seq_r=find_condition.group(1).replace(match_start,'').replace(match_end,'')

        for i in [gap_related_seq,gap_related_seq_r]:
            if i=='':continue
            fw1.write("clr:%s gap_related_seq:%s\n"%(clr,i))
            if filled_seq.get(i):
                filled_seq[i]+=1
            else:
                filled_seq[i]=1

    #choose seq with biggest value(count)
    #if two biggest vaule(count) are same, random choose one
    try:
        replace_seq=sorted(filled_seq,key=filled_seq.__getitem__,reverse=True)[0]
        if filled_seq[replace_seq]<=1:
            new_seq='x'
            print 'Not Found.'
        else:#appreance is big than 2
            new_seq=tmp_seq[0]+replace_seq+tmp_seq[1]
            print replace_seq
            fw1.write("Replace with :%s "%replace_seq)
    except:
        new_seq='x'
        print 'Not Found.'
    return new_seq

def rename(my_path,my_output,header):
    f=open(my_path)
    d=dict()
    for i in f:
        i=i.replace('\n','')
        if '>' in i:h=i;d[h]='';continue
        d[h]+=i
    f.close()

    fw=open(my_output,'w')
    count=1
    for i in d.keys():
        seq=d[i]
        h='>'+header+'_'+str(count)+'_len:'+str(len(seq))
        fw.write(h+'\n')
        fw.write(seq+'\n')
        count+=1
    fw.close()

try:
    ref=sys.argv[1]
    corrected_CLR=sys.argv[2]
except:
    ref='CISA_E100.fa'
    corrected_CLR='my_CLR.fa'

#f=open(ref);header=f.readline();f.close()
#if not '_len:' in header:
rename(ref,'my_ref.fa','ref');ref='my_ref.fa'
#f=open(corrected_CLR);header=f.readline();f.close()
#if not '_len:' in header:
rename(corrected_CLR,'my_CLR.fa','clr');corrected_CLR='my_CLR.fa'


    
ctg_dict=Get_Seq(ref)
clr_dict=Get_Seq(corrected_CLR)

filled_ctg=dict()
fw=open('Filled_'+ref,'w')
fw1=open('Filled_info.txt','w')
for ctg in ctg_dict.keys():
    seq=ctg_dict[ctg]
    filled_ctg[ctg]=seq#suppose, the seq doesn't have N
   
    # Start to jduge if N in seq
    filled_seq=seq    
    while True:
        if not 'N' in filled_seq:break#one time process one N block
        fw1.write(ctg+'\n');print ctg
        filled_seq=Gap_Filler(filled_seq,clr_dict,fw1)
        if filled_seq != 'x':
            filled_ctg[ctg]=filled_seq
            
for ctg in filled_ctg.keys():
    new_header=ctg.split(':')[0]+':'+str(len(filled_ctg[ctg]))
    fw.write(new_header+'\n')
    fw.write(filled_ctg[ctg]+'\n')
fw.close();fw1.close()
        
