import sys,os
import commands

def Run_SOAP2(my_path,read1,read2,min_i,max_i,bwtbuilder,soap):
    print 'Start SOAPaligner'
    comm="cp %s my_contig.fa"%my_path
    print comm
    (s,o)=commands.getstatusoutput(comm)    
    #comm="2bwt-builder my_contig"
    comm="%s my_contig.fa"%bwtbuilder
    print comm
    (s,o)=commands.getstatusoutput(comm)
    #comm="soap -a %s -b %s -D my_contig.index -M 0 -r 2 -p 6 -o PE_Result -2 SE_Result -m %s -x %s"%(read1,read2,min_i,max_i)
    comm="%s -a %s -b %s -D my_contig.fa.index -M 0 -r 2 -p 6 -o PE_Result -2 SE_Result -m %s -x %s"%(soap,read1,read2,min_i,max_i)
    print comm
    o=commands.getoutput(comm)
    fw=open("SOAP_Output.txt","w")
    fw.write(o)
    fw.close()
def Run_SOAP2_S(my_path,read,bwtbuilder,soap):
    print 'Start SOAPaligner'
    comm="cp %s my_contig.fa"%my_path
    print comm
    (s,o)=commands.getstatusoutput(comm)    
    #comm="2bwt-builder my_contig"
    comm="%s my_contig.fa"%bwtbuilder
    print comm
    (s,o)=commands.getstatusoutput(comm)
    #comm="soap -a %s -b %s -D my_contig.index -M 0 -r 2 -p 6 -o PE_Result -2 SE_Result -m %s -x %s"%(read1,read2,min_i,max_i)
    comm="%s -a %s -D my_contig.fa.index -M 0 -r 2 -p 6 -o Result "%(soap,read)
    print comm
    o=commands.getoutput(comm)
    fw=open("SOAP_Output.txt","w")
    fw.write(o)
    fw.close()   
def To_Split(output_ref,depth,in_sam):
    my_d=dict()
    f=open("my_contig.fa")
    for i in f:
        if '>' in i:h=i.replace('>','').replace('\n','');my_d[h]='';continue
        my_d[h]+=i.replace('\n','')
    f.close()
    my_dict=dict()
    for k in my_d.keys():
        my_dict[k]=[0]*len(my_d[k])
    print 'Read Contig Done!'
    f=open(in_sam)
    for i in f:
        tmp=i.split()
        now_contig=tmp[7]
        posi=int(tmp[8])-1
        read_len=len(tmp[1])
        for x in range(read_len):
            my_dict[now_contig][posi+x]+=1
    f.close()
    print 'Read SAM File Done!'
    #depth in my_dict
    #seq in my_d
    process_count=0
    process_contig=[]
    fw=open(output_ref,'w')
    for k in my_dict.keys():
        my_depth=my_dict[k]
        my_seq=list(my_d[k])
        for i in range(len(my_depth)):
            if my_depth[i]<=depth :my_seq[i]='-'#if depth too small , change opposite position sequence to '-'
            #if my_depth[i]==0 :my_seq[i]='-'#if depth is 0 , change opposite position sequence to '-'
            
        my_new_seq=''.join(my_seq)
        my_new_seq_list=my_new_seq.split('-')
        if len(my_new_seq_list)==1:#it doesn't be splited.
            fw.write('>'+k+'\n');fw.write(my_new_seq_list[0]+'\n')
        else:
            process_count+=1
            count=1
            partial_name=k.split('len')[0]+k.split(':')[1]
            if len([seq for seq in my_new_seq_list if len(seq)>0])==1:type_name='_trimmed_'
            else:type_name='_split_'
            process_contig.append(partial_name+type_name)
            for seq in my_new_seq_list:
                if len(seq)<=50:continue#if new seq's length <= 50, skip it.
                fw.write('>'+partial_name+type_name+str(count)+'_len:'+str(len(seq))+'\n')
                fw.write(seq+'\n')
                count+=1
    fw.close()
    if os.path.exists(in_sam):os.remove(in_sam)
    if os.path.exists('SE_Result'):os.remove('SE_Result')
    (s,o)=commands.getstatusoutput("rm my_contig.fa*")

def To_Split_Use_coords_result(my_path,my_ctg_cover_dict,output_ref):
    f=open(my_path)
    my_ctg=dict()
    for i in f:
        i=i.replace('\n','')
        if '>' in i:h=i.replace('>','');my_ctg[h]='';continue
        my_ctg[h]+=i
    f.close()

    fw=open(output_ref,'w')
    #Get depth
    for ctg in my_ctg.keys():
        seq=my_ctg[ctg];
        if not my_ctg_cover_dict.get(ctg):
            fw.write('>%s\n'%ctg);fw.write(seq+'\n');continue
        cover_info=my_ctg_cover_dict[ctg]
        ctg_len=int(ctg.split(':')[1])
        depth_list=[0]*ctg_len

        #ignore header and tail, range is ctg_len * 0.01
        skip_range=int(ctg_len*0.01)
        for x in range(skip_range):depth_list[x]+=1
        for x in range(ctg_len-1,ctg_len-skip_range-1,-1):depth_list[x]+=1#from ctg_len to cet_len-skip_range, a time minus one 
    
        for i in cover_info:
            s1=i[0];s2=i[1]
            for j in range(s1,s2):
                depth_list[j]+=1
        seq_list=list(seq)
        for i in range(len(depth_list)):    
            if depth_list[i]==0 :seq_list[i]='-'
            
        my_new_seq=''.join(seq_list)
        my_new_seq_list=my_new_seq.split('-')
        
        if len(my_new_seq_list)==1:#it doesn't be splited.
            fw.write('>%s\n'%ctg);fw.write(my_new_seq_list[0]+'\n')
        else:
            count=1
            partial_name=ctg.split('len')[0]+ctg.split(':')[1]
            
            if len([p_seq for p_seq in my_new_seq_list if len(p_seq)>0])==1:type_name='_trimmed_'
            else:type_name='_split_'

            for p_seq in my_new_seq_list:
                if len(p_seq)<=50:continue#if new seq's length <= 50, skip it.
                p_seq_start=seq.index(p_seq);p_seq_end=p_seq_start+len(p_seq)
                fw.write('>'+partial_name+type_name+str(count)+'_'+str(p_seq_start)+'_'+str(p_seq_end)+'_len:'+str(len(p_seq))+'\n')
                fw.write(p_seq+'\n')
                count+=1
    fw.close()
def Get_Unused_CLR(my_path,my_used_clr_set,rest_CLR):
    f=open(my_path);fw=open(rest_CLR,'w')
    while True:
        h=f.readline()
        if not h:break
        seq=f.readline()
        h1=h.replace('\n','').replace('>','')
        if h1 in my_used_clr_set:continue
        fw.write(h);fw.write(seq)
    f.close();fw.close()

def Do_Nucmer(nucmer,corrected_CLR):
    command="%s --maxmatch -o my_ctg %s"%(nucmer,corrected_CLR)
    #-o means output coords
    (s,o)=commands.getstatusoutput(command)
    
def Do_Nucmer(nucmer,ref,corrected_CLR):
    command="%s --maxmatch -o %s %s"%(nucmer,ref,corrected_CLR)
    (s,o)=commands.getstatusoutput(command)

def Get_Ref(ref):
    d=dict()
    f=open(ref)
    while True:
        h=f.readline()
        if not h:break
        seq=f.readline()
        d[h]=seq
    f.close()
    return d

def rename(my_path,my_output,header):
    f=open(my_path)
    d=dict()
    for i in f:
        i=i.replace('\n','')
        if '>' in i:h=i;d[h]='';continue
        d[h]+=i
    f.close()

    fw=open(my_output,'w')
    count=1
    for i in d.keys():
        seq=d[i]
        h='>'+header+'_'+str(count)+'_len:'+str(len(seq))
        fw.write(h+'\n')
        fw.write(seq+'\n')
        count+=1
    fw.close()

nucmer=sys.argv[1]
try:
    ref=sys.argv[2]
    corrected_CLR=sys.argv[3]
    read1=sys.argv[4]
    read2=sys.argv[5]
    min_i=sys.argv[6]
    max_i=sys.argv[7]
    depth=int(sys.argv[8])
    bwtbuilder=sys.argv[9]
    soap=sys.argv[10]
except:
    nucmer='nucmer'
    ref='CISA_E100.fa'
    corrected_CLR='PacBio_Illumia.fasta'
    depth=0
    bwtbuilder='2bwt-builder'
    soap='soap'

output_ref='Split_Ref.fa'
rest_CLR='Unused_CLR.fa'


print "Start to Split!"
#To_Split_Use_coords_result(ref,my_ctg_dict,output_ref)
if read1!='no' and read2!='no':
    Run_SOAP2(ref,read1,read2,min_i,max_i,bwtbuilder,soap)
    in_sam='PE_Result'
    To_Split(output_ref,depth,in_sam)
    print "Done."
else:
    reads_file=[read1,read2]
    reads_file.remove('no')
    Run_SOAP2_S(ref,reads_file[0],bwtbuilder,soap)
    in_sam='Result'
    To_Split(output_ref,depth,in_sam)
    print "Done."    
#print "Start to Get Unused CLR."
#Get_Unused_CLR(corrected_CLR,my_used_clr_set,rest_CLR)
#print "Done."

















