def remove_explained(my_file):
    f=open(my_file)
    my_dict=dict()
    for i in f:
        if '#' in i:continue
        tmp=i.split()
        if my_dict.get(tmp[0]):my_dict[tmp[0]].append(i.replace('\n',''))
        else:
            tmp_l=[]
            tmp_l.append(i.replace('\n',''))
            my_dict[tmp[0]]=tmp_l
    f.close()
    #if whole bridge bps are cover by side contigs. remove it. 
    condition1_bridge=dict()
    for k in my_dict.keys():
        explained=False
        k_len=int(k.split(':')[1])
        tmpl=my_dict[k]
        new_list=[]
        for i in tmpl:
            tmp=i.split()
            if tmp[0]==tmp[1]:continue#Edena_36_54642_split_1_len:48359	Edena_36_54642_split_1_len:48359	30294	30573	30181	30460	282	6e-127	247
            new_list.append(i)
            side_cover_start=int(tmp[2])
            side_cover_end=int(tmp[3])
            #if bridge is totally explained by a side. skip it
            if (side_cover_start==1 and side_cover_end==k_len) or (side_cover_start==k_len and side_cover_end==1):explained=True
        if not explained:
            condition1_bridge[k]=new_list
    return condition1_bridge

def to_write(file_name,my_dict):
    fw=open(file_name,'w')
    for k in my_dict.keys():
        for i in my_dict[k]:fw.write(i+'\n')
    fw.close()

def remove_multiple(condition1_bridge,ambiguous):
    condition2_bridge=dict()
    tmp_bridge=dict()
    tmp_bridge_1=dict()
    #1 get matched side
    fw_bad_bridge=open('Bad_Bridge.txt','w')
    for k in condition1_bridge.keys():
        my_used_data=[]
        bridge_head_2_side=[]
        bridge_tail_2_side=[]
        for i in condition1_bridge[k]:
            tmp=i.split()
            side_len=int(tmp[1].split(':')[1]);bridge_l=int(tmp[0].split(':')[1])
            side_start=int(tmp[4]);side_end=int(tmp[5])
            bridge_s=int(tmp[2]);bridge_e=int(tmp[3])
            #get side tail or head info
            if (side_start>=1 and side_start<=ambiguous) or (side_end<=side_len and side_end>=(side_len-ambiguous)):my_used_data.append(i)
            elif (side_end>=1 and side_end<=ambiguous) or (side_start<=side_len and side_start>=(side_len-ambiguous)):my_used_data.append(i)
            #if side_start==1 or side_start==side_len or side_end==1 or side_end==side_len : my_used_data.append(i)
            
            #get bridge info and if bridge head or tail overlap with side is not No1, skip this bridge
            #bridge tail info
            #clr_2301_len:1646     Abyss_190_3942_trimmed_1_len:3906     260     1646     1     1387     1387     0.0     1387
            #bridge head info
            #clr_2301 head overlap with side. No1 is 731 but it is not side's head or tail. skip this bridge.
            #clr_2301_len:1646     Velvet_226_219934_split_1_len:8872     2     831     4020     3191     831     0.0     731 
            #clr_2301_len:1646     Connected_Contig_2_14_len:42603     2     356     355     1     355     2e-178     337
            
            if (bridge_s>=1 and bridge_s<=ambiguous):bridge_head_2_side.append(i)
            if (bridge_e<=bridge_l and bridge_e>=(bridge_l-ambiguous)): bridge_tail_2_side.append(i)

        #if bridge's head or tail No1 is not in Side's head or tail list ( my_used_data ), skip it
        #to sort bridge's head and tail info(bridge's head or tail maybe at side's head, tail or middle)
        bridge_head_2_side.sort(key=lambda x:int(x.split()[-1]),reverse=True)
        bridge_tail_2_side.sort(key=lambda x:int(x.split()[-1]),reverse=True)

        ## if no2 occupy no1's 80% => ambigous(no1 and no2 is too similar) => continue
        #no1 or no2 maybe is bridge's head or tail at side's head, tail or middle.
        #check side1 and bridge's condition
        if len(bridge_head_2_side)>=2:
            side1_no1=bridge_head_2_side[0];side1_no2=bridge_head_2_side[1]
            tmp=side1_no1.split();no1_s=int(tmp[2]);no1_e=int(tmp[3]);no1_range=float(abs(no1_e-no1_s))
            tmp=side1_no2.split();no2_s=int(tmp[2]);no2_e=int(tmp[3]);no2_range=float(abs(no2_e-no2_s))
            if (no2_range/no1_range)>=0.8:
                for bad_b in bridge_head_2_side:fw_bad_bridge.write(bad_b+'\n')
                for bad_b in bridge_tail_2_side:fw_bad_bridge.write(bad_b+'\n')
                #print 'aaaaaaaaaaaaa'
                continue
        #check side2 and bridge's condition
        if len(bridge_tail_2_side)>=2:
            side2_no1=bridge_tail_2_side[0];side2_no2=bridge_tail_2_side[1]
            tmp=side2_no1.split();no1_s=int(tmp[2]);no1_e=int(tmp[3]);no1_range=float(abs(no1_e-no1_s))
            tmp=side2_no2.split();no2_s=int(tmp[2]);no2_e=int(tmp[3]);no2_range=float(abs(no2_e-no2_s))
            if (no2_range/no1_range)>=0.8:
                for bad_b in bridge_head_2_side:fw_bad_bridge.write(bad_b+'\n')
                for bad_b in bridge_tail_2_side:fw_bad_bridge.write(bad_b+'\n')
                #print 'bbbbbbbb'
                continue  


        #give up the bridge if the bridge's No1 overlap is not at Side's tail or head.
        try:
            # if bridge_head_2_side or bridge_tail_2_side is empty, continue
            if not bridge_head_2_side[0] in my_used_data:continue
            if not bridge_tail_2_side[0] in my_used_data:continue
        except:
            continue
        
        if len(my_used_data)>0:tmp_bridge[k]=my_used_data
    to_write('1_condition2_1.txt',tmp_bridge)
    #2 if it has multiple sides, choose the side which has bigger overlap as the connected side.
    #2.1 get brideg side 1 and side 2 data list
    for k in tmp_bridge.keys():
        tmp=dict();
        tmp['bridge_side1']=[];tmp['bridge_side2']=[]
        tmp_bridge_1[k]=tmp
    for k in tmp_bridge.keys():
        for i in tmp_bridge[k]:
            tmp=i.split()
            bridge_len=int(tmp[0].split(':')[1])
            bridge_side1=int(tmp[2]);bridge_side2=int(tmp[3])
            #get bridge's tail or head info, and extension or bridge info.
            if (bridge_side1>=1 and bridge_side1<=ambiguous) or (bridge_side1<=bridge_len and bridge_side1>=(bridge_len-ambiguous)):tmp_bridge_1[k]['bridge_side1'].append(i)
            if (bridge_side2>=1 and bridge_side2<=ambiguous) or (bridge_side2<=bridge_len and bridge_side2>=(bridge_len-ambiguous)):tmp_bridge_1[k]['bridge_side2'].append(i)
    #2.2 Get side 1 or side 2 which overlap is the bigger, the bigger side is ths connected side.
    #    and get extension data ( bridge only connect one side).
    #fw_e=open('1_Extensions.txt','w')
    fw_e=open('Extensions.tmp','w')
    #fw_bad_side=open('Bad_Side.txt','w')
    tmp_d=dict()
    for k in tmp_bridge_1.keys():
        side1=tmp_bridge_1[k]['bridge_side1']
        side2=tmp_bridge_1[k]['bridge_side2']
        if len(side1) == 0 or len(side2) == 0:
            #only for extension, doesn't be used to connect two sides.
            #1 Skip bridge which can be connected multiple extensions
            #2 Skip extension which can be connected to multiple bridge
            if len(side1)==1:
                tmp_data=side1[0].split();side_name=tmp_data[1]
                if not tmp_d.get(side_name):tmp_d[side_name]=1;fw_e.write(side1[0]+'\n')
            if len(side2)==1:
                tmp_data=side2[0].split();side_name=tmp_data[1]
                if not tmp_d.get(side_name):tmp_d[side_name]=1;fw_e.write(side2[0]+'\n')            
            continue
        print '%d,%d'%(len(side1),len(side2))

        side1.sort(key=lambda x:int(x.split()[-1]),reverse=True)
        side2.sort(key=lambda x:int(x.split()[-1]),reverse=True)
        my_list=[];
        my_list.append(side1[0])
        my_list.append(side2[0])
        condition2_bridge[k]=my_list
    fw_e.close();fw_bad_bridge.close();#fw_bad_side.close()
    #to_write('1_Bridges.txt',condition2_bridge)
    to_write('Bridges.tmp',condition2_bridge)
    return condition2_bridge

def filter_bridge(my_file,my_replace_name_2):
    bridges_info=[]
    f=open(my_file)
    for i in f:
        bridges_info.append(i)
    f.close()
    fw=open('1_Bridges.txt','w')
    for i in range(0,len(bridges_info),2):
        #infos of sides are same,skip
        tmp=bridges_info[i].split()
        b_s1=tmp[0]+'\t'+tmp[1]
        tmp=bridges_info[i+1].split()
        b_s2=tmp[0]+'\t'+tmp[1]
        if b_s1==b_s2:continue
        
        #if bridges or sides of Bridge.txt are in replace_info, skip it
        # and overlap have to be over 0.1 * bridge's length
        #get side1 info
        tmp=bridges_info[i].split()
        bridge_length=int(tmp[0].split(':')[1])
        side1_alignment=int(tmp[-1].replace('\n',''))
        side1_length=int(tmp[1].split(':')[1])
        if (tmp[0] in my_replace_name_2) or (tmp[1] in my_replace_name_2):continue

        #get side2 info
        tmp=bridges_info[i+1].split()
        side2_alignment=int(tmp[-1].replace('\n',''))
        side2_length=int(tmp[1].split(':')[1])
        if (tmp[0] in my_replace_name_2) or (tmp[1] in my_replace_name_2):continue

        #bridge_ratio=0.001*float(bridge_length)
        bridge_ratio=20
        if side1_alignment<bridge_ratio or side2_alignment<bridge_ratio:continue

        fw.write(bridges_info[i])
        fw.write(bridges_info[i+1])
    fw.close()

def filter_extension(my_file,my_replace_name_2):
    bridges_info=[]
    f=open(my_file);fw=open('1_Extensions.txt','w')
    for i in f:
        tmp=i.split()
        b_len=int(tmp[0].split(':')[1])
        s_len=int(tmp[1].split(':')[1])
        if b_len<200 or s_len<200:continue

        #overlap have to be over 0.2* bridge
        side_alignment=int(tmp[-1].replace('\n',''))
        bridge_length=int(tmp[0].split(':')[1])
        bridge_ratio=0.3*float(bridge_length)
        if side_alignment<bridge_ratio :continue
        
        #if bridges or sides of Extensions.txt are in replace_info, skip it
        #if (tmp[0] in my_replace_name_2) or (tmp[1] in my_replace_name_2):continue
        fw.write(i)
    fw.close();f.close()

def replace_data(my_file):
    my_replace_name_1=[]
    my_replace_list_1=[]
# Fields: query id, subject id, q. start, q. end, s. start, s. end, alignment length, evalue, score
#Velvet_439_len:2026	Extended_Contig_3_len:1500	10	1510	1	1500	1500	0.0	1500
    f=open(my_file);
    for i in f:
        if '#' in i:continue
        i=i.replace('\n','')
        tmp=i.split()
        b_len=int(tmp[0].split(':')[1])
        s_len=int(tmp[1].split(':')[1])
        align_len=int(tmp[-3])
        score=int(tmp[-1])
        if align_len==score==s_len and b_len>s_len:
            explained_ratio=float(s_len)/float(b_len)
            if explained_ratio>=0.7:
                my_replace_name_1.append(tmp[0])#append bridge
                my_replace_name_1.append(tmp[1])#append side
                my_replace_list_1.append(i)
    f.close();
    return (my_replace_list_1,my_replace_name_1)

def filter_replace_list(my_replace_list_1,my_replace_name_1):
    fw=open('1_Replace_data.txt','w')
    my_replace_name_2=[]
    my_replace_list_2=[]    
    for i in my_replace_list_1:
        tmp=i.split()
        #if it has multiple replaced choices, skip it
        if my_replace_name_1.count(tmp[0]) > 1:continue
        if my_replace_name_1.count(tmp[1]) > 1:continue
        my_replace_list_2.append(i)
        my_replace_name_2.append(tmp[0])#append bridge
        my_replace_name_2.append(tmp[1])#append side
        fw.write(i+'\n')
    fw.close()
    return (my_replace_list_2,my_replace_name_2)

#condition 1 remove bridges which are explained by side.
#condition 2 remove bridges which can connect multiple paired sides.
#condition 3 remove bridges which are explained by left and right sides.
my_file='My_result.txt'
ambiguous=10#10 bp tolerant range
#remove_explained(my_file)
condition1_bridge=remove_explained(my_file)
condition2_bridge=remove_multiple(condition1_bridge,ambiguous)
to_write('1_condition1.txt',condition1_bridge)
to_write('1_condition2.txt',condition2_bridge)
(my_replace_list_1,my_replace_name_1)=replace_data(my_file)
(my_replace_list_2,my_replace_name_2)=filter_replace_list(my_replace_list_1,my_replace_name_1)
filter_bridge('Bridges.tmp',my_replace_name_2)
filter_extension('Extensions.tmp',my_replace_name_2)
                            




